Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkContourGrid Class Reference

`#include <vtkContourGrid.h>`

Inheritance diagram for vtkContourGrid:

[legend]
Collaboration diagram for vtkContourGrid:

[legend]
List of all members.

## Detailed Description

generate isosurfaces/isolines from scalar values (specialized for unstructured grids)

Date:
  2003/01/09 19:21:05

Revision:
  1.16

vtkContourGrid is a filter that takes as input datasets of type vtkUnstructuredGrid and generates on output isosurfaces and/or isolines. The exact form of the output depends upon the dimensionality of the input data. Data consisting of 3D cells will generate isosurfaces, data consisting of 2D cells will generate isolines, and data with 1D or 0D cells will generate isopoints. Combinations of output type are possible if the input dimension is mixed.

To use this filter you must specify one or more contour values. You can either use the method SetValue() to specify each contour value, or use GenerateValues() to generate a series of evenly spaced contours. It is also possible to accelerate the operation of this filter (at the cost of extra memory) by using a vtkScalarTree. A scalar tree is used to quickly locate cells that contain a contour surface. This is especially effective if multiple contours are being extracted. If you want to use a scalar tree, invoke the method UseScalarTreeOn().

If the input data is structured, consider using a filter that is optimized for structured data. These can be found in the patented classes of vtk.

Warning:
  For unstructured data or structured grids, normals and gradients are not computed. Use vtkPolyDataNormals to compute the surface normals of the resulting isosurface.

See also:
  vtkMarchingContourFilter vtkKitwareContourFilter vtkMarchingCubes vtkSliceCubes vtkDividingCubes vtkMarchingSquares vtkImageMarchingCubes

Created by:
  - Henderson, Amy

CVS contributions (if > 5%):
  - Henderson, Amy (62%)
  - Martin, Ken (16%)
  - Schroeder, Will (9%)

CVS logs (CVSweb):
  - .`cxx` (`/Graphics/vtkContourGrid.cxx)`
  - .`h` (`/Graphics/vtkContourGrid.h)`

Definition at line 78 of file vtkContourGrid.h.

## Public Types
typedef vtkUnstructuredGridToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
unsigned long | GetMTime ()
void | CreateDefaultLocator ()
void | SetValue (int i, float value)
float | GetValue (int i)
float * | GetValues ()
void | GetValues (float *contourValues)
void | SetNumberOfContours (int number)
int | GetNumberOfContours ()
void | GenerateValues (int numContours, float range[2])
void | GenerateValues (int numContours, float rangeStart, float rangeEnd)
virtual void | SetComputeNormals (int)
virtual int | GetComputeNormals ()
virtual void | ComputeNormalsOn ()
virtual void | ComputeNormalsOff ()
virtual void | SetComputeGradients (int)
virtual int | GetComputeGradients ()
virtual void | ComputeGradientsOn ()
virtual void | ComputeGradientsOff ()
virtual void | SetComputeScalars (int)
virtual int | GetComputeScalars ()
virtual void | ComputeScalarsOn ()
virtual void | ComputeScalarsOff ()
virtual void | SetUseScalarTree (int)
virtual int | GetUseScalarTree ()
virtual void | UseScalarTreeOn ()
virtual void | UseScalarTreeOff ()
void | SetLocator (vtkPointLocator *locator)
virtual vtkPointLocator * | GetLocator ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkContourGrid * | SafeDownCast (vtkObject *o)
vtkContourGrid * | New ()
## Protected Methods
| vtkContourGrid ()
| ~vtkContourGrid ()
void | Execute ()
virtual void | SetInputScalarsSelection (const char *)
virtual char * | GetInputScalarsSelection ()
void | SelectInputScalars (const char *fieldName)
## Protected Attributes
vtkContourValues * | ContourValues
int | ComputeNormals
int | ComputeGradients
int | ComputeScalars
vtkPointLocator * | Locator
int | UseScalarTree
vtkScalarTree * | ScalarTree
vtkEdgeTable * | EdgeTable
char * | InputScalarsSelection
## Friends
class | vtkContourFilter

## Member Typedef Documentation

typedef vtkUnstructuredGridToPolyDataFilter vtkContourGrid::Superclass

| Reimplemented from vtkUnstructuredGridToPolyDataFilter. Definition at line 81 of file vtkContourGrid.h.

## Constructor & Destructor Documentation

vtkContourGrid::vtkContourGrid | ( |  | ) | `[protected]`

vtkContourGrid::~vtkContourGrid | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkContourGrid::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkUnstructuredGridToPolyDataFilter.

int vtkContourGrid::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkUnstructuredGridToPolyDataFilter.

virtual int vtkContourGrid::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkUnstructuredGridToPolyDataFilter.

vtkContourGrid* vtkContourGrid::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkUnstructuredGridToPolyDataFilter.

void vtkContourGrid::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkUnstructuredGridToPolyDataFilter.

vtkContourGrid* vtkContourGrid::New | ( |  | ) | `[static]`

| Construct object with initial range (0,1) and single contour value of 0.0. Reimplemented from vtkObject.

void vtkContourGrid::SetValue | ( | int | i,
|  | float | value
| ) | `[inline]`

| Methods to set / get contour values. Definition at line 192 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::SetValue().

float vtkContourGrid::GetValue | ( | int | i | ) | `[inline]`

| Get the ith contour value. Definition at line 197 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::GetValue().

float * vtkContourGrid::GetValues | ( |  | ) | `[inline]`

| Get a pointer to an array of contour values. There will be GetNumberOfContours() values in the list. Definition at line 204 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::GetValues().

void vtkContourGrid::GetValues | ( | float * | contourValues | ) | `[inline]`

| Fill a supplied list with contour values. There will be GetNumberOfContours() values in the list. Make sure you allocate enough memory to hold the list. Definition at line 211 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::GetValues().

void vtkContourGrid::SetNumberOfContours | ( | int | number | ) | `[inline]`

| Set the number of contours to place into the list. You only really need to use this method to reduce list size. The method SetValue() will automatically increase list size as needed. Definition at line 217 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::SetNumberOfContours().

int vtkContourGrid::GetNumberOfContours | ( |  | ) | `[inline]`

| Get the number of contours in the list of contour values. Definition at line 222 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::GetNumberOfContours().

void vtkContourGrid::GenerateValues | ( | int | numContours,
|  | float | range[2]
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 229 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::GenerateValues().

void vtkContourGrid::GenerateValues | ( | int | numContours,
|  | float | rangeStart,
|  | float | rangeEnd
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 236 of file vtkContourGrid.h. References ContourValues, and vtkContourValues::GenerateValues().

unsigned long vtkContourGrid::GetMTime | ( |  | ) | `[virtual]`

| Modified GetMTime Because we delegate to vtkContourValues Reimplemented from vtkObject.

virtual void vtkContourGrid::SetComputeNormals | ( | int |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkContourGrid::GetComputeNormals | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkContourGrid::ComputeNormalsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkContourGrid::ComputeNormalsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkContourGrid::SetComputeGradients | ( | int |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkContourGrid::GetComputeGradients | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkContourGrid::ComputeGradientsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkContourGrid::ComputeGradientsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkContourGrid::SetComputeScalars | ( | int |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual int vtkContourGrid::GetComputeScalars | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkContourGrid::ComputeScalarsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkContourGrid::ComputeScalarsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkContourGrid::SetUseScalarTree | ( | int |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

virtual int vtkContourGrid::GetUseScalarTree | ( |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

virtual void vtkContourGrid::UseScalarTreeOn | ( |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

virtual void vtkContourGrid::UseScalarTreeOff | ( |  | ) | `[virtual]`

| Enable the use of a scalar tree to accelerate contour extraction.

void vtkContourGrid::SetLocator | ( | vtkPointLocator * | locator | ) |

| Set / get a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

virtual vtkPointLocator* vtkContourGrid::GetLocator | ( |  | ) | `[virtual]`

| Set / get a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

void vtkContourGrid::CreateDefaultLocator | ( |  | ) |

| Create default locator. Used to create one when none is specified. The locator is used to merge coincident points.

virtual char* vtkContourGrid::GetInputScalarsSelection | ( |  | ) | `[protected, virtual]`

| If you want to contour by an arbitrary array, then set its name here. By default this in NULL and the filter will use the active scalar array.

void vtkContourGrid::SelectInputScalars | ( | const char * | fieldName | ) | `[inline, protected]`

| If you want to contour by an arbitrary array, then set its name here. By default this in NULL and the filter will use the active scalar array. Definition at line 165 of file vtkContourGrid.h.

void vtkContourGrid::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

virtual void vtkContourGrid::SetInputScalarsSelection | ( | const char * |  | ) | `[protected, virtual]`

## Friends And Related Function Documentation

friend class vtkContourFilter`[friend]`

| Definition at line 158 of file vtkContourGrid.h.

## Member Data Documentation

vtkContourValues* vtkContourGrid::ContourValues`[protected]`

| Definition at line 173 of file vtkContourGrid.h. Referenced by GenerateValues(), GetNumberOfContours(), GetValue(), GetValues(), SetNumberOfContours(), and SetValue().

int vtkContourGrid::ComputeNormals`[protected]`

| Definition at line 174 of file vtkContourGrid.h.

int vtkContourGrid::ComputeGradients`[protected]`

| Definition at line 175 of file vtkContourGrid.h.

int vtkContourGrid::ComputeScalars`[protected]`

| Definition at line 176 of file vtkContourGrid.h.

vtkPointLocator* vtkContourGrid::Locator`[protected]`

| Definition at line 177 of file vtkContourGrid.h.

int vtkContourGrid::UseScalarTree`[protected]`

| Definition at line 178 of file vtkContourGrid.h.

vtkScalarTree* vtkContourGrid::ScalarTree`[protected]`

| Definition at line 179 of file vtkContourGrid.h.

vtkEdgeTable* vtkContourGrid::EdgeTable`[protected]`

| Definition at line 180 of file vtkContourGrid.h.

char* vtkContourGrid::InputScalarsSelection`[protected]`

| Definition at line 182 of file vtkContourGrid.h.

The documentation for this class was generated from the following file:

- Graphics/vtkContourGrid.h